/***********************************************************************************
 * 
 */

#include "Battery.h"
#include "Registers.h"

uint8_t batteryLevel;
float batteryValue;

void Battery_init() {
  //
  // Allocates battery pin
  //
  pinMode(PIN_BATTERY, INPUT);  
}


float Battery_getValue() {
  //
  // Read voltage level from tension divider bridge 1M/680K
  // Reference value is 3.3v
  // Values are not reliable
  //
  const float N = 10.0;
  // The value is computed as the mean of N samples
  float voltage = 0;
  for (int i=1; i<=N; i++) {
    voltage += analogRead(PIN_BATTERY) / 4096.0 * 3.3  ;   //  value is 4096 for 3,3 volts
    delay(1);
  }
  voltage = (voltage/N)*1.7;       // Tension divider bridge 1M/680K

  return voltage;
}

int Battery_getPercentLevel() {
  //
  // returns percentage 0..100 of remaining charge
  //
  int percentage;

  float voltage = Battery_getValue();
  Serial.println("POWER - Battery value = " + String(voltage));
  if (voltage >= VMAX) percentage = 100;
  else if (voltage <= VMIN) percentage = 0;
  else percentage = round((voltage - VMIN) / (VMAX - VMIN) * 100.0);
  Serial.println("POWER - Battery level = " + String(percentage) + "%");  
  return percentage;
}
